// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from py_trees_ros_interfaces:msg/ActivityItem.idl
// generated code does not contain a copyright notice

#include "py_trees_ros_interfaces/msg/detail/activity_item__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_py_trees_ros_interfaces
const rosidl_type_hash_t *
py_trees_ros_interfaces__msg__ActivityItem__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x28, 0xc7, 0xd5, 0x19, 0xbc, 0xdd, 0x43, 0x7b,
      0x10, 0x8a, 0x25, 0x71, 0x66, 0x9e, 0xf7, 0xe4,
      0x8a, 0x0f, 0xf0, 0x05, 0xdc, 0xaf, 0x2f, 0x99,
      0x0d, 0x77, 0x5f, 0xac, 0x82, 0x0f, 0x6d, 0xa9,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char py_trees_ros_interfaces__msg__ActivityItem__TYPE_NAME[] = "py_trees_ros_interfaces/msg/ActivityItem";

// Define type names, field names, and default values
static char py_trees_ros_interfaces__msg__ActivityItem__FIELD_NAME__key[] = "key";
static char py_trees_ros_interfaces__msg__ActivityItem__FIELD_NAME__client_name[] = "client_name";
static char py_trees_ros_interfaces__msg__ActivityItem__FIELD_NAME__activity_type[] = "activity_type";
static char py_trees_ros_interfaces__msg__ActivityItem__FIELD_NAME__previous_value[] = "previous_value";
static char py_trees_ros_interfaces__msg__ActivityItem__FIELD_NAME__current_value[] = "current_value";

static rosidl_runtime_c__type_description__Field py_trees_ros_interfaces__msg__ActivityItem__FIELDS[] = {
  {
    {py_trees_ros_interfaces__msg__ActivityItem__FIELD_NAME__key, 3, 3},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_STRING,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {py_trees_ros_interfaces__msg__ActivityItem__FIELD_NAME__client_name, 11, 11},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_STRING,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {py_trees_ros_interfaces__msg__ActivityItem__FIELD_NAME__activity_type, 13, 13},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_STRING,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {py_trees_ros_interfaces__msg__ActivityItem__FIELD_NAME__previous_value, 14, 14},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_STRING,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {py_trees_ros_interfaces__msg__ActivityItem__FIELD_NAME__current_value, 13, 13},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_STRING,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
py_trees_ros_interfaces__msg__ActivityItem__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {py_trees_ros_interfaces__msg__ActivityItem__TYPE_NAME, 40, 40},
      {py_trees_ros_interfaces__msg__ActivityItem__FIELDS, 5, 5},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "##############################################################################\n"
  "#\n"
  "# A single blackboard activity item\n"
  "#\n"
  "#    key: the active blackboard key\n"
  "#    client_name : name of the blackboard client accessing the key\n"
  "#    activity_type: type of operation attempted on the ky\n"
  "#    previous_value: if the key was modified, stores the previous value of the key\n"
  "#    current_value: if the key was modified, stores the current value of the key\n"
  "#\n"
  "##############################################################################\n"
  "\n"
  "# Activity types\n"
  "string READ = \"READ\"\n"
  "string INITIALISED = \"INITIALISED\"\n"
  "string WRITE = \"WRITE\"\n"
  "string ACCESSED = \"ACCESSED\"\n"
  "string ACCESS_DENIED = \"ACCESS_DENIED\"\n"
  "string NO_KEY = \"NO_KEY\"\n"
  "string NO_OVERWRITE = \"NO_OVERWRITE\"\n"
  "string UNSET = \"UNSET\"\n"
  "\n"
  "string key\n"
  "string client_name\n"
  "string activity_type\n"
  "string previous_value\n"
  "string current_value";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
py_trees_ros_interfaces__msg__ActivityItem__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {py_trees_ros_interfaces__msg__ActivityItem__TYPE_NAME, 40, 40},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 870, 870},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
py_trees_ros_interfaces__msg__ActivityItem__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *py_trees_ros_interfaces__msg__ActivityItem__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
